#line 1 "C:/Users/Giuseppe/Documents/mikroC/ExtRes_to_AT45DB/ExtRes_to_AT45DB.c"
#line 41 "C:/Users/Giuseppe/Documents/mikroC/ExtRes_to_AT45DB/ExtRes_to_AT45DB.c"
sbit LCD_D4 at LATB0_bit;
sbit LCD_D5 at LATB1_bit;
sbit LCD_D6 at LATB2_bit;
sbit LCD_D7 at LATB3_bit;
sbit LCD_RS at LATB4_bit;
sbit LCD_EN at LATB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;
sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;



sbit Mmc_Chip_Select at LATC0_bit;
sbit Mmc_Chip_Select_Direction at TRISC0_bit;
sbit Mmc_Card_Detect at RC1_bit;
sbit Mmc_Card_Detect_Direction at TRISC1_bit;



sbit AT45DB_Chip_Select at LATC2_bit;
sbit AT45DB_Chip_Select_Direction at TRISC2_bit;



char memSeries;
unsigned long memSize;
unsigned long resFileSize;
unsigned short SPI_StatusReg1;
unsigned short SPI_StatusReg2;
char readBuffer[512];



const char txt_01[] = "Insert microSD  ";
const char txt_02[] = "MicroSD inserted";
const char txt_03[] = "MicroSD error!  ";
const char txt_04[] = "FAT16 not found ";
const char txt_05[] = "Reinsert & reset";
const char txt_06[] = "Memory not found";
const char txt_07[] = "Turn off & check";
const char txt_08[] = "AT45DBxx1D found";
const char txt_09[] = "AT45DBxx1E found";
const char txt_10[] = "No supported mem";
const char txt_11[] = "device connected";
const char txt_12[] = "Not enough space";
const char txt_13[] = "to store Ext Res";
const char txt_14[] = "Press RA0 button";
const char txt_15[] = "to start writing";
const char txt_16[] = "Page size is now";
const char txt_17[] = "set to 512 bytes";
const char txt_18[] = "Writing data to ";
const char txt_19[] = "AT45DB memory...";
const char txt_20[] = "Error writing to";
const char txt_21[] = "45DBxx1E memory.";
const char txt_22[] = "Data written to ";
const char txt_23[] = "AT45DB memory.  ";


void Terminate() {
 Mmc_Fat_Close();
 while (1) {
 Delay_ms(1000);
 }
}


char* CodeTxtToRamTxt(const char* ctxt) {
 static char ramTxt[17];
 unsigned short i;
 for (i = 0; ramTxt[i] = ctxt[i]; i++);
 return ramTxt;
}


void Wait_for_Card() {
 Mmc_Card_Detect_Direction = 1;

 if (Mmc_Card_Detect) {
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1,1,CodeTxtToRamTxt(txt_01));
 while (Mmc_Card_Detect) {
 Delay_ms(500);
 }
 Lcd_Out(1,1,CodeTxtToRamTxt(txt_02));
 Delay_ms(2000);
 }
}


void Card_Init() {

 SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV64, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);

 switch (Mmc_Fat_Init()) {
 case 1:
 Lcd_Out(1,1,CodeTxtToRamTxt(txt_03));
 Lcd_Out(2,1,CodeTxtToRamTxt(txt_04));
 Terminate();
 case 255:
 Lcd_Out(1,1,CodeTxtToRamTxt(txt_03));
 Lcd_Out(2,1,CodeTxtToRamTxt(txt_05));
 Terminate();
 }


 SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV4, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);

 Mmc_Fat_Assign("res_file.res", 0);
 Mmc_Fat_Reset(&resFileSize);
}

void AT45DB_ReadStatusReg() {
 AT45DB_Chip_Select = 0;
 SPI1_Write(0xD7);
 SPI_StatusReg1 = SPI1_Read(0xFF);
 SPI_StatusReg2 = SPI1_Read(0xFF);
 AT45DB_Chip_Select = 1;
}

void AT45DB_Check() {
 unsigned short density;

 AT45DB_Chip_Select = 1;
 AT45DB_Chip_Select_Direction = 0;

 AT45DB_ReadStatusReg();
 if (SPI_StatusReg1 == 0x00 || SPI_StatusReg1 == 0xFF) {
 Lcd_Out(1,1,CodeTxtToRamTxt(txt_06));
 Lcd_Out(2,1,CodeTxtToRamTxt(txt_07));
 Terminate();
 }
 if (SPI_StatusReg1 == SPI_StatusReg2) {
 memSeries = 'D';
 Lcd_Out(1,1,CodeTxtToRamTxt(txt_08));
 } else {
 memSeries = 'E';
 Lcd_Out(1,1,CodeTxtToRamTxt(txt_09));
 }
 Delay_ms(3000);

 density = SPI_StatusReg1 & 0b00111100;
 switch (density) {
 case 0b00101100:
 memSize = 2097152;
 break;
 case 0b00110100:
 memSize = 4194304;
 break;
 default:
 Lcd_Out(1,1,CodeTxtToRamTxt(txt_10));
 Lcd_Out(2,1,CodeTxtToRamTxt(txt_11));
 Terminate();
 }

 if (memSize < resFileSize) {
 Lcd_Out(1,1,CodeTxtToRamTxt(txt_12));
 Lcd_Out(2,1,CodeTxtToRamTxt(txt_13));
 Terminate();
 }
}


void AT45DB_Write() {
 unsigned short hiAddr;
 unsigned short medAddr;
 unsigned long tempAddr;
 unsigned long i;
 unsigned long cycles;
 unsigned int j;
 unsigned int remainder;
 char character;

 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(1,1,CodeTxtToRamTxt(txt_14));
 Lcd_Out(2,1,CodeTxtToRamTxt(txt_15));

 do {
 if (Button(&PORTA, 0, 1, 1))
 break;
 } while (1);

 AT45DB_ReadStatusReg();


 if ((SPI_StatusReg1 & 0b00000001) == 0) {
 AT45DB_Chip_Select = 0;
 SPI1_Write(0x3D);
 SPI1_Write(0x2A);
 SPI1_Write(0x80);
 SPI1_Write(0xA6);
 AT45DB_Chip_Select = 1;
 Lcd_Out(1,1,CodeTxtToRamTxt(txt_16));
 Lcd_Out(2,1,CodeTxtToRamTxt(txt_17));
 Delay_ms(3000);
 }

 Lcd_Out(1,1,CodeTxtToRamTxt(txt_18));
 Lcd_Out(2,1,CodeTxtToRamTxt(txt_19));

 cycles = resFileSize / 512;
 remainder = resFileSize % 512;

 for (i = 0; i < cycles; i++) {
 for (j = 0; j < 512; j++) {
 Mmc_Fat_Read(&character);
 readBuffer[j]=character;
 }

 tempAddr = i << 9;
 hiAddr = (unsigned short) (tempAddr >> 16);
 medAddr = (unsigned short) ((tempAddr & 0xFF00) >> 8);

 do {
 AT45DB_ReadStatusReg();
 } while ((SPI_StatusReg1 & 0b10000000) == 0);

 if (memSeries == 'E')
 if ((SPI_StatusReg2 & 0b00100000) != 0) {
 Lcd_Out(1,1,CodeTxtToRamTxt(txt_20));
 Lcd_Out(2,1,CodeTxtToRamTxt(txt_21));
 Terminate();
 }

 AT45DB_Chip_Select = 0;
 SPI1_Write(0x82);
 SPI1_Write(hiAddr);
 SPI1_Write(medAddr);
 SPI1_Write(0x00);
 for (j = 0; j < 512; j++)
 SPI1_Write(readBuffer[j]);
 AT45DB_Chip_Select = 1;
 }

 for (j = 0; j < remainder; j++) {
 Mmc_Fat_Read(&character);
 readBuffer[j]=character;
 }

 tempAddr = i << 9;
 hiAddr = (unsigned short) (tempAddr >> 16);
 medAddr = (unsigned short) ((tempAddr & 0xFF00) >> 8);

 do {
 AT45DB_ReadStatusReg();
 } while ((SPI_StatusReg1 & 0b10000000) == 0);

 if (memSeries == 'E')
 if ((SPI_StatusReg2 & 0b00100000) != 0) {
 Lcd_Out(1,1,CodeTxtToRamTxt(txt_20));
 Lcd_Out(2,1,CodeTxtToRamTxt(txt_21));
 Terminate();
 }

 AT45DB_Chip_Select = 0;
 SPI1_Write(0x82);
 SPI1_Write(hiAddr);
 SPI1_Write(medAddr);
 SPI1_Write(0x00);
 for (j = 0; j < remainder; j++)
 SPI1_Write(readBuffer[j]);
 for (j = remainder; j < 512; j++)
 SPI1_Write(0x00);
 AT45DB_Chip_Select = 1;

 Lcd_Out(1,1,CodeTxtToRamTxt(txt_22));
 Lcd_Out(2,1,CodeTxtToRamTxt(txt_23));
}


void main() {
 ANSELA = 0;
 ANSELB = 0;
 ANSELC = 0;
 SLRCON = 0;
 TRISA = 0x01;

 Lcd_Init();
 Wait_for_Card();
 Card_Init();
 AT45DB_Check();
 AT45DB_Write();
}
